# Class SimpleElementVisitorPreview<R,P>

java.lang.Object
javax.lang.model.util.AbstractElementVisitor6<R,P>
javax.lang.model.util.SimpleElementVisitor6<R,P>
javax.lang.model.util.SimpleElementVisitor7<R,P>
javax.lang.model.util.SimpleElementVisitor8<R,P>
javax.lang.model.util.SimpleElementVisitor9<R,P>
javax.lang.model.util.SimpleElementVisitor14<R,P>
javax.lang.model.util.SimpleElementVisitorPreview<R,P>

Type Parameters:
  `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
  `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.

All Implemented Interfaces:
  `ElementVisitor<R,P>`

@SupportedSourceVersion(RELEASE_27) public class SimpleElementVisitorPreview<R,P> extends SimpleElementVisitor14<R,P>
`SimpleElementVisitorPreview` is a reflective preview API of the Java platform.
Preview features may be removed in a future release, or upgraded to permanent features of the Java platform.
A simple visitor of program elements with default behavior appropriate for a preview source version. Visit methods corresponding to `RELEASE_14` and earlier language constructs call `defaultAction`, passing their arguments to `defaultAction`'s corresponding parameters.

API Note:
  Methods in this class may be overridden subject to their general contract.
Since:
  23
See Also:
  - Expected visitor evolution
  - Compatibility note for subclasses
  - `SimpleElementVisitor6`
  - `SimpleElementVisitor7`
  - `SimpleElementVisitor8`
  - `SimpleElementVisitor9`
  - `SimpleElementVisitor14`

## Field Summary

### Fields declared in class SimpleElementVisitor6

`DEFAULT_VALUE`
Modifier and Type
Field
Description
`protected final R`
`DEFAULT_VALUE`
Default value to be returned; `defaultAction` returns this value unless the method is overridden.

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`SimpleElementVisitorPreview()`
Constructor for concrete subclasses; uses `null` for the default value.
`protected`
`SimpleElementVisitorPreview(R defaultValue)`
Constructor for concrete subclasses; uses the argument for the default value.

## Method Summary

### Methods declared in class SimpleElementVisitor14

`visitRecordComponent`
Modifier and Type
Method
Description
`R`
`visitRecordComponent(RecordComponentElement e, P p)`
Visits a record component element.

### Methods declared in class SimpleElementVisitor9

`visitModule`
Modifier and Type
Method
Description
`R`
`visitModule(ModuleElement e, P p)`
Visits a module element.

### Methods declared in class SimpleElementVisitor7

`visitVariable`
Modifier and Type
Method
Description
`R`
`visitVariable(VariableElement e, P p)`
Visits a variable element.

### Methods declared in class SimpleElementVisitor6

`defaultAction, visitExecutable, visitPackage, visitType, visitTypeParameter`
Modifier and Type
Method
Description
`protected R`
`defaultAction(Element e, P p)`
The default action for visit methods.
`R`
`visitExecutable(ExecutableElement e, P p)`
Visits an executable element.
`R`
`visitPackage(PackageElement e, P p)`
Visits a package element.
`R`
`visitType(TypeElement e, P p)`
Visits a type element.
`R`
`visitTypeParameter(TypeParameterElement e, P p)`
Visits a type parameter element.

### Methods declared in class AbstractElementVisitor6

`visit, visit, visitUnknown`
Modifier and Type
Method
Description
`final R`
`visit(Element e)`
Visits any program element as if by passing itself to that element's `accept` method and passing `null` for the additional parameter.
`final R`
`visit(Element e, P p)`
Visits any program element as if by passing itself to that element's `accept` method.
`R`
`visitUnknown(Element e, P p)`
Visits an unknown kind of element.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`String`
`toString()`
Returns a string representation of the object.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Constructor Details

### SimpleElementVisitorPreview

protected SimpleElementVisitorPreview()
Constructor for concrete subclasses; uses `null` for the default value.

### SimpleElementVisitorPreview

protected SimpleElementVisitorPreview(R defaultValue)
Constructor for concrete subclasses; uses the argument for the default value.

Parameters:
  `defaultValue` - the value to assign to `SimpleElementVisitor6.DEFAULT_VALUE`